;===========================================================================================
; Edit.asm  Fasm Flat assembler
; EDIT class
; pas de resource, id, controle total de control class
; Programm par AsmGges France
;===========================================================================================
; nb: edit 1 ligne ou combobox h=20

format PE GUI 4.0
entry start

; Inclusion des macros/quates/structures ncessaires au programme
; ----------------------------------------------------------------
  include 'win32a.inc'
  include 'macro\if.inc'

  ID_GBOX      = 100
  ID_EDIT1     = 101
  ID_EDIT2     = 102
  ID_SEE_EDIT2 = 103

;===========================================================================================
; Dbut du code programme
; -----------------------
section '.code' code readable executable

 start:
    ; Obtenir le handle du programme
    ; ------------------------------
    invoke GetModuleHandle,0
    mov [wc.hInstance],eax

    ; Chargement d'une icne spcifique
    ; ---------------------------------
    invoke LoadIcon,[wc.hInstance],IDI_FRANCE
    mov [wc.hIcon],eax

    ; Chargement d'un curseur systme
    ; -------------------------------
    invoke LoadCursor,0,IDC_ARROW
    mov [wc.hCursor],eax

    ; Obtenir la largeur en pixels de l'cran
    ; ---------------------------------------
    invoke GetSystemMetrics,SM_CXSCREEN
    sub eax,[WinW]
    shr eax,1
    mov [WinX],eax

    ; Valider la structure WNDCLASS
    ; -----------------------------
    invoke RegisterClass,wc

    ; Cration de la fenetre de l'application
    ; ---------------------------------------
    invoke CreateWindowEx,0,ClassName,Titre,WS_CAPTION+WS_POPUP+WS_SYSMENU+\
                          WS_MINIMIZEBOX,[WinX],[WinY],[WinW],[WinH],0,0,[wc.hInstance],0
    mov [hWnd],eax

    ; Affiche et rafraichit la fenetre
    ; --------------------------------
    invoke ShowWindow,[hWnd],SW_SHOWDEFAULT
    invoke UpdateWindow,[hWnd]

 ; Boucle des messages
 ; -------------------
 MessageLoop:
    invoke GetMessage,msg,NULL,0,0
    or eax,eax
    jz ExitProgram
    invoke TranslateMessage,msg
    invoke DispatchMessage,msg
    jmp MessageLoop

 ExitProgram:
    ; Fermeture de l'application
    ; --------------------------
    invoke ExitProcess,[msg.wParam]

;===========================================================================================
; Procdure principale Windows
;-------------------------------------------------------------------------------------------
proc WindowProc uses ebx esi edi, @hWnd, @uMsg, @wParam, @lParam

    .if [@uMsg] = WM_CLOSE
        ; Boite  message fin d'application
        ; ---------------------------------
        invoke MessageBox,[@hWnd],MsgEnd,ClassName,MB_OK+MB_ICONINFORMATION

        ; Demande fin d'application
        ; -------------------------
        invoke PostQuitMessage,0

    .elseif [@uMsg] = WM_CREATE
        ; Dfinir une fonte de texte
        ; --------------------------
        invoke CreateFont,8,0,0,0,FW_NORMAL,0,0,0,ANSI_CHARSET,OUT_DEFAULT_PRECIS,\
                       CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH+FF_SWISS,\
                                                                      MSSansSerif
        mov [hFontMSSS],eax                      ;font handle

        ; Construit tous les controles
        ; ----------------------------
        stdcall CreateControls,[@hWnd]

    .elseif [@uMsg] = WM_COMMAND
        ; Click souris pour identification du bouton actionn
        ; ---------------------------------------------------
        .if [@wParam] = BN_CLICKED shl 16+ID_SEE_EDIT2

            ; Met dans le buffer le texte de la fenetre du control EDIT
            ; ---------------------------------------------------------
            invoke GetDlgItemText,[@hWnd],ID_EDIT2,Buffer,256
            invoke MessageBox,[@hWnd],Buffer,ClassName,MB_OK+MB_ICONINFORMATION

        .endif

    .else
        ; Traitement par dfaut des autres messages Windows
        ; -------------------------------------------------
        invoke DefWindowProc,[@hWnd],[@uMsg],[@wParam],[@lParam]
        ret

    .endif

    mov eax,0
    ret
endp

;===========================================================================================
proc CreateControls @hWnd

    ; Cration de la fenetre-enfant GroupBox
    ; --------------------------------------
    stdcall Dlg,Button,GbGges,[@hWnd],4,2,286,20,ID_GBOX,BS_GROUPBOX,0

    ;=======================================================================================
    ; Titre du controle Edit1
    ; -----------------------
    stdcall Dlg,Static,StaticLs,[@hWnd],70,24,160,16,-1,0,0

    ; Cration de la sous-fenetre Edit1 lecture seulement
    ; ---------------------------------------------------
    stdcall Dlg,Edit,NoText,[@hWnd],70,40,160,56,ID_EDIT1,WS_BORDER+ES_WANTRETURN+\
                                              WS_VSCROLL+ES_MULTILINE+ES_READONLY,\
                                                           WS_EX_OVERLAPPEDWINDOW

    ; Ecrit un texte dans un controle EDIT
    ; ------------------------------------
    invoke SetDlgItemText,[@hWnd],ID_EDIT1,TexteEdit

    ;=======================================================================================
    ; Titre du controle Edit2
    ; -----------------------
    stdcall Dlg,Static,StaticLe,[@hWnd],70,104,160,16,-1,0,0

    ; Cration de la sous-fenetre Edit2 lecture/criture
    ; --------------------------------------------------
    stdcall Dlg,Edit,Edit2Txt,[@hWnd],70,120,160,70,ID_EDIT2,WS_BORDER+ES_WANTRETURN+\
                                       WS_HSCROLL+WS_VSCROLL+ES_MULTILINE+WS_TABSTOP,\
                                                              WS_EX_OVERLAPPEDWINDOW

    ;---------------------------------------------------------------------------------------
    ; Bouton pour rcuprer la ligne affiche dans la fenetre edit2
    ; -------------------------------------------------------------
    stdcall Dlg,Button,BtnTxt,[@hWnd],70,198,160,22,ID_SEE_EDIT2,BS_PUSHBUTTON,0

    ret
endp

;===========================================================================================
; Cration d'une fenetre-enfant control class
;-------------------------------------------------------------------------------------------
; @Class    = adresse du nom de control class
; @AddrText = adresse du control text
; @hParent  = handle de la fenetre parent
; @X        = x-coordonne fenetre-enfant
; @Y        = y-coordonne fenetre-enfant
; @Xw       = largeur en pixels fenetre-enfant
; @Yh       = hauteur en pixels fenetre-enfant
; @Id       = identificateur du controle forme ID_XXX
; @Style    = complment window style de WS_CHILD+WS_VISIBLE
; @ExStyle  = window style tendu
;-------------------------------------------------------------------------------------------
; sortie eax = handle de la fenetre-enfant
;-------------------------------------------------------------------------------------------
proc Dlg @Class, @AddrText, @hParent, @X, @Y, @Xw, @Yh, @Id, @Style, @ExStyle

    mov eax,WS_CHILD+WS_VISIBLE
    add eax,[@Style]
    invoke CreateWindowEx,[@ExStyle],[@Class],[@AddrText],eax,[@X],[@Y],[@Xw],[@Yh],\
                          [@hParent],[@Id],[wc.hInstance],NULL
    mov ebx,eax

    ; Valider la fonte standard MS Sans Serif pour le control
    ; -------------------------------------------------------
    invoke SendMessage,ebx,WM_SETFONT,[hFontMSSS],NULL
    mov eax,ebx

    ret
endp

;===========================================================================================
; Dfinitions des datas chaines / variables initialises ou non initialises / structures
;-------------------------------------------------------------------------------------------
section '.data' data readable writeable

  Titre     db ' EDIT control',0
  ClassName db ' AsmGges Win32',0
  MsgEnd    db ' AsmGges France @2006  ',0
  TexteEdit db 'Vous ne pouvez pas crire directement du texte dans cette fentre.',13,10
            db 'Elle est en lecture seule.',0

  GbGges      db 'AsmGges Edit',0
  NoText      db '',0
  StaticLs    db 'Lecture seule:',0
  StaticLe    db 'Lecture / Ecriture:',0
  Edit2Txt    db 'Entrez votre texte',0
  BtnTxt      db 'Voir le texte dit',0

  MSSansSerif db 'MS Sans Serif',0

  Button      db 'BUTTON',0
  Static      db 'STATIC',0
  Edit        db 'EDIT',0

  align 4

  WinX        dd 0
  WinY        dd 100
  WinW        dd 300
  WinH        dd 264

  Buffer      rb 256       ;buffer pour dition de texte

  hWnd        dd ?
  hFontMSSS   dd ?

  wc          WNDCLASS  0, WindowProc, 0, 0, 0, 0, 0, COLOR_BTNFACE+1, 0, ClassName
  msg         MSG

;===========================================================================================
; Inclusion des fichiers .dll contenant les fonctions Windows utilises
;-------------------------------------------------------------------------------------------
section '.idata' import data readable writeable

  library kernel32,'KERNEL32.DLL',\
            user32,'USER32.DLL',\
             gdi32,'GDI32.DLL'

  ; Apis Windows dans fichiers dlls
  ; -------------------------------
  include 'apia\kernel32.inc'
  include 'apia\user32.inc'
  include 'apia\gdi32.inc'

;===========================================================================================
; Inclusion des icnes / curseurs / bitmap
;-------------------------------------------------------------------------------------------
section '.rsrc' resource data readable

  directory RT_ICON,icons,\
            RT_GROUP_ICON,group_icons

  IDI_FRANCE = 17

  resource icons,\
           1,LANG_NEUTRAL,icon_data

  resource group_icons,\
           IDI_FRANCE,LANG_NEUTRAL,main_icon

  icon main_icon,icon_data,'res\france.ico'

;===========================================================================================
